Unit CmplFrt;
interface
uses Windows, classes, Sysutils, u1, u2, u3, u4;
procedure CompileForth(prg : pchar; fn_exe : string);

implementation

const
  zaglushka:array[1..15] of byte = ( $8c, $c8, $8e, $d8, {mov ax, cs ; mov ds, ax}
                                   $ba, $0f, $00,      {mov dx, 0fh}
                                   $b4, $09, $cd, $21, {mov ah, 9h ; int 21h}
                                   $b4, $4c, $cd, $21  {mov ah, 4ch ; int 21h}
                                 );
var
  stroka:array[0..100] of char;
  code_size,
  data_size : dword;
  size_of_image,
  size_of_head : dword;
  _BaseOfCode,
  _BaseOfData,
  _ImageBase,
  _fCode, _fszCode,
  _fData, _fszData : dword;
  _Subsystem : word;
  EntryPoint : string;
  ImpFun : array[1..100] of record
                              nm : string[50];
                              adr : dword;
                            end;
  ImpFunNow : integer;

  word_now : string;

  s_count : word;

function FindAddrImport(nm: string):dword;
var
 i : integer;
begin
  for i := 1 to 100 do
    if nm = ImpFun[i].nm then
       begin
         Result := ImpFun[i].adr;
         exit;
       end;
  Result := 0;
end;

function Import_1(p : pointer; adr : dword; mas : array of byte;
                                            masn : array of string):dword;
type
  ArrayDllDef = packed record
                  aaif1 : dword;
                  tmp1, tmp2 :dword;
                  nd : dword;
                  aaif2 : dword;
                end;
var
  i, j, k : integer;
  pz, pzn : dword;
  nn : ArrayDllDef;
  buffn : array[0..100] of char;
  tmp : dword;
begin
  ImpFunNow := 1;
  //  
  pz := (High(mas)+2)*20;
  for i := 0 to High(mas) do pz := pz + (mas[i]+1)*4*2;
  //
  j := 0;
  pzn := (High(mas)+2)*20;
  for i := 0 to High(mas)+1 do
     begin
       if i = High(mas)+1 then FillChar(nn, sizeof(nn),#0)
       else
         begin
           nn.aaif1 := adr + pzn;
           nn.tmp1 := 0;
           nn.tmp2 := 0;
           nn.nd := adr + pz;
             // dll
             StrPCopy(buffn, masn[j]);
             Move(buffn, pointer(dword(p)+pz)^, strlen(buffn)+1);
             pz := pz + strlen(buffn)+1;
             inc(j);
           nn.aaif2 := adr + pzn + (mas[i]+1)*4;
             // 
             for k := 1 to mas[i] do
               begin
                 //----  ---
                 tmp := adr + pz;
                 Move(tmp, pointer(dword(p)+pzn+(k-1)*4)^, 4);
                 Move(tmp, pointer(dword(p)+pzn+(mas[i]+1)*4+(k-1)*4)^, 4);
                 //----------
                 ImpFun[ImpFunNow].nm := masn[j];
                 ImpFun[ImpFunNow].adr := adr + pzn+(mas[i]+1)*4+(k-1)*4;
                 inc(ImpFunNow);
                 //---------------------------
                 StrPCopy(buffn, masn[j]);
                 Move(nn.tmp2, pointer(dword(p)+pz)^, 2);
                 Move(buffn, pointer(dword(p)+pz+2)^, strlen(buffn)+1);
                 pz := pz + strlen(buffn)+1+2;
                 inc(j);
               end;
             //----   ---
             tmp := 0;
             Move(tmp, pointer(dword(p)+pzn+mas[i]*4)^, 4);
             Move(tmp, pointer(dword(p)+pzn+(mas[i]+1)*4*2 - 4)^, 4);
           pzn := pzn + (mas[i]+1)*4*2;
         end;
       Move(nn, pointer(dword(p)+20*i)^, sizeof(nn));
     end;
  Result := pz;
end;

function _DateExe: cardinal;
const
  ds:array[1..12] of byte = (31,28,31,30,31,30,31,31,30,31,30,31);
var
  st : _SYSTEMTIME;
  i  : integer;
begin
  DateTimeToSystemTime(now, st);
  Result := 0;
  for i := 1970 to  (st.wYear - 1) do
      if IsLeapYear(i) then Result := Result + 366*24*60*60
      else Result := Result + 365*24*60*60;
  for i := 1 to  (st.wMonth - 1) do
      if IsLeapYear(i) and (i=2) then Result := Result + 29*24*60*60
      else Result := Result + ds[i]*24*60*60;
  Result := Result + (st.wDay-1)*24*60*60 + st.wHour*60*60 + st.wMinute*60 + st.wSecond;
end;



procedure CompileForth(prg : pchar; fn_exe : string);
var
  fs : TMemoryStream;
  headDos : TImageDosHeader;
  inh : TImageNtHeaders;
  ish : TImageSectionHeader;
  //
  szi : dword;
  tmp : dword;
  //
  _size : word;
  _adr : dword;
  _stroka : string;
  //
  i : integer;
begin

  u2.now_obj_prog := 0;

  u3.bp := 1;

  u1.prog := prg;
  u1.poz := 0;
  u1.token_type := u1.UNKNOW;

  word_now := '';

  u4.now_obj_z := 0;

  stroka :='Forth 4.2 for Windows (delphi5) $';

  _Subsystem := IMAGE_SUBSYSTEM_WINDOWS_CUI;
  size_of_head := $1000;
  size_of_image := $6000;

  _BaseOfCode := $1000;
  _BaseOfData := $4000;

  _fCode :=  $400;
  _fszCode := $800;
  _fData :=  _fCode + _fszCode;
  _fszData := $400;

  _ImageBase := $10000;

  EntryPoint := 'main';

  fs := TMemoryStream.Create;
  fs.SetSize(_fData + _fszData);
  FillChar((fs.Memory)^, fs.Size, #$90);
  FillChar(headDos, sizeof(headDos),#0);
  headDos.e_magic := IMAGE_DOS_SIGNATURE; {MZ}
  headDos.e_cblp := 64+15+strlen(stroka); {-     }
  headDos.e_cp := 1; {  -  }
  headDos.e_crlc := 0; {- -   }
  headDos.e_cparhdr := 4; {   }
  headDos.e_maxalloc := $ffff;
  headDos.e_sp := $b8;
  headDos.e_ip := 0;
  headDos.e_cs := 0;
  headDos.e_lfarlc :=  $40; { PE-}
  headDos._lfanew := 256;
  fs.Position := 0;
  fs.WriteBuffer(headDos, sizeof(headDos));
  //--------------------------------
  fs.WriteBuffer(zaglushka, sizeof(zaglushka));
  fs.WriteBuffer(stroka, strlen(stroka));
  //------------PE-----------------
  fs.Position := 256;
  FillChar(inh, sizeof(inh), #0);
  inh.Signature := IMAGE_NT_SIGNATURE; {PE/0/0}
  inh.FileHeader.Machine := IMAGE_FILE_MACHINE_I386;
  inh.FileHeader.NumberOfSections := 3;  {- }
  inh.FileHeader.TimeDateStamp := _DateExe;
  inh.FileHeader.SizeOfOptionalHeader := 224; {  }
  inh.FileHeader.Characteristics := $818f;
  inh.OptionalHeader.Magic := $010b;
  inh.OptionalHeader.MajorLinkerVersion := 4;
  inh.OptionalHeader.MinorLinkerVersion := 2;
  inh.OptionalHeader.SizeOfCode := code_size;
  inh.OptionalHeader.SizeOfInitializedData := data_size;
  inh.OptionalHeader.SizeOfUninitializedData := 0;
  inh.OptionalHeader.AddressOfEntryPoint := $1000; { }
  inh.OptionalHeader.BaseOfCode := _BaseOfCode;
  inh.OptionalHeader.BaseOfData := _BaseOfData;
  inh.OptionalHeader.ImageBase := _ImageBase;
  inh.OptionalHeader.SectionAlignment := $1000;
  inh.OptionalHeader.FileAlignment := $200;
  inh.OptionalHeader.MajorOperatingSystemVersion := 1;
  inh.OptionalHeader.MinorOperatingSystemVersion := 0;
  inh.OptionalHeader.MajorImageVersion := 0;
  inh.OptionalHeader.MinorImageVersion := 0;
  inh.OptionalHeader.MajorSubsystemVersion := 3;
  inh.OptionalHeader.MinorSubsystemVersion := 10;
  inh.OptionalHeader.SizeOfImage := size_of_image;
  inh.OptionalHeader.SizeOfHeaders := size_of_head;
  inh.OptionalHeader.CheckSum := 0;
  inh.OptionalHeader.Subsystem := _Subsystem;
  inh.OptionalHeader.SizeOfStackReserve := 0;
  inh.OptionalHeader.SizeOfStackCommit := 0;
  inh.OptionalHeader.SizeOfHeapReserve := 0;
  inh.OptionalHeader.SizeOfHeapCommit := 0;
  inh.OptionalHeader.NumberOfRvaAndSizes := 16;
        //----------------------------------------
        szi := Import_1(pointer(dword(fs.Memory) + _fData) , _BaseOfData,
                        [5,2],
                        ['kernel32.dll', 'ExitProcess', 'GetStdHandle', 'GetProcAddress', 'LoadLibraryA', 'WriteConsoleA', 'user32.dll', 'MessageBoxA', 'wsprintfA']);
        //----------------------------------------
  inh.OptionalHeader.DataDirectory[1].VirtualAddress := _BaseOfData;    {import}
  inh.OptionalHeader.DataDirectory[1].Size := szi;
  fs.WriteBuffer(inh, sizeof(inh));
  //----------------------------------
  FillChar(ish, sizeof(ish), #0);
  strcopy(pchar(@(ish.Name)), '.code');
  ish.VirtualAddress := _BaseOfCode;
  ish.Misc.VirtualSize := $3000;
  ish.SizeOfRawData := _fszCode;
  ish.PointerToRawData := _fCode;
  ish.Characteristics := IMAGE_SCN_CNT_CODE or IMAGE_SCN_MEM_EXECUTE or IMAGE_SCN_MEM_READ or IMAGE_SCN_MEM_WRITE;
  fs.WriteBuffer(ish, sizeof(ish));
  FillChar(ish, sizeof(ish), #0);
  strcopy(pchar(@(ish.Name)), '.data');
  ish.VirtualAddress := _BaseOfData;
  ish.Misc.VirtualSize := $1000;
  ish.SizeOfRawData := _fszData;
  ish.PointerToRawData := _fData;
  ish.Characteristics := IMAGE_SCN_CNT_INITIALIZED_DATA or IMAGE_SCN_MEM_READ or IMAGE_SCN_MEM_WRITE;
  fs.WriteBuffer(ish, sizeof(ish));
  FillChar(ish, sizeof(ish), #0);
  strcopy(pchar(@(ish.Name)), '.kf');
  ish.VirtualAddress := _BaseOfData + $1000;
  ish.Misc.VirtualSize := $1000;
  ish.SizeOfRawData := 0;
  ish.PointerToRawData := 0;
  ish.Characteristics := IMAGE_SCN_CNT_UNINITIALIZED_DATA or IMAGE_SCN_MEM_READ or IMAGE_SCN_MEM_WRITE;
  fs.WriteBuffer(ish, sizeof(ish));
  //----------------------------------------
  fs.Position := _fCode;

  _stroka := 'about';
  tmp := u2.Add('about', _BaseOfData + szi, length(_stroka)+1);
  StrCopy(pchar(dword(fs.Memory) + _fData + (tmp - _BaseOfData) ),Pchar(_stroka));
  _stroka := 'Forth 4.2 for Windows'+ #13#10 +'Alex F. Kudimov' + #13#10 +'e-mail: kufal@list.ru' ;
  tmp := u2.Add('about_m', $ffffffff, length(_stroka)+1);
  StrCopy(pchar(dword(fs.Memory) + _fData + (tmp - _BaseOfData) ),Pchar(_stroka));
  _stroka := '%10li';
  tmp := u2.Add('lpFmt', $ffffffff, length(_stroka)+1);
  StrCopy(pchar(dword(fs.Memory) + _fData + (tmp - _BaseOfData) ),Pchar(_stroka));
  tmp := u2.Add('lpOut', $ffffffff, 16);
  tmp := u2.Add('msg_l', $ffffffff, 4);
  tmp := u2.Add('STDOUT', $ffffffff, 4);
  tmp := u2.Add('here', $ffffffff, 4); //    
  pdword(dword(fs.Memory) + _fData + (tmp - _BaseOfData) )^ := _ImageBase + _BaseOfData + $1000;
  tmp := u2.Add('data_create', $ffffffff, 4); //  create

  while u1.token_type <> u1.FINISH do
    begin
      u1.GetToken1;
      //MessageBox(0,Pchar(u1.token),'',0);
      if u1.token = 'quit' then
         begin
           tmp:=$6A; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1);   {push 0; i32}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('ExitProcess')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call ebx}
           continue;
         end;
      if u1.token = 'about' then
         begin
           tmp:=$6A; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1);   {push 0; i32}
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('about', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push 0}
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('about_m', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push 0}
           tmp:=$6A; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1);   {push 0; i32}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('MessageBoxA')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call ebx}
           continue;
         end;
      if u1.token = 'drop' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           continue;
         end;
      if u1.token = 'dup' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'swap' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           tmp:=$53; fs.Write(tmp, 1);   {push ebx}
           continue;
         end;
      if u1.token = 'over' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$53; fs.Write(tmp, 1);   {push ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           tmp:=$53; fs.Write(tmp, 1);   {push ebx}
           continue;
         end;
      if u1.token = 'rot' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$59; fs.Write(tmp, 1);   {pop ecx}
           tmp:=$53; fs.Write(tmp, 1);   {push ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           tmp:=$51; fs.Write(tmp, 1);   {push ecx}
           continue;
         end;
      if u1.token = '-rot' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$59; fs.Write(tmp, 1);   {pop ecx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           tmp:=$51; fs.Write(tmp, 1);   {push ecx}
           tmp:=$53; fs.Write(tmp, 1);   {push ebx}
           continue;
         end;
      if u1.token = '.' then
         begin
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('lpFmt', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push offset lpFmt}
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('lpOut', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push offset lpOut}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('wsprintfA')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call ebx}
           tmp:=$83; fs.Write(tmp, 1);
           tmp:=$c4; fs.Write(tmp, 1);
           tmp:=$0c; fs.Write(tmp, 1); {add esp, 4*3}
           tmp:=$6A; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1);   {push 0; i32}
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('msg_l', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push offset msg_l}
           tmp:=$68; fs.Write(tmp, 1);
           tmp:=10; fs.Write(tmp, 4);   {push 10}
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('lpOut', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push i32}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$35; fs.Write(tmp, 1);
           u2.Find('STDOUT', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push m32}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('WriteConsoleA')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call ebx}
           continue;
         end;
      if u1.token = '-' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$29; fs.Write(tmp, 1);
           tmp:=$d8; fs.Write(tmp, 1);   {sub eax, ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '+' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$01; fs.Write(tmp, 1);
           tmp:=$d8; fs.Write(tmp, 1);   {add eax, ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '*' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$f7; fs.Write(tmp, 1);
           tmp:=$eb; fs.Write(tmp, 1);   {imul ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'negate' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$f7; fs.Write(tmp, 1);
           tmp:=$d8; fs.Write(tmp, 1);   {neg eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '/' then
         begin
           tmp:=$31; fs.Write(tmp, 1);
           tmp:=$d2; fs.Write(tmp, 1);   {xor edx, edx}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$f7; fs.Write(tmp, 1);
           tmp:=$fb; fs.Write(tmp, 1);   {idiv ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'mod' then
         begin
           tmp:=$31; fs.Write(tmp, 1);
           tmp:=$d2; fs.Write(tmp, 1);   {xor edx, edx}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$f7; fs.Write(tmp, 1);
           tmp:=$fb; fs.Write(tmp, 1);   {idiv ebx}
           tmp:=$52; fs.Write(tmp, 1);   {push edx}
           continue;
         end;
      if u1.token = '/mod' then
         begin
           tmp:=$31; fs.Write(tmp, 1);
           tmp:=$d2; fs.Write(tmp, 1);   {xor edx, edx}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$f7; fs.Write(tmp, 1);
           tmp:=$fb; fs.Write(tmp, 1);   {idiv ebx}
           tmp:=$52; fs.Write(tmp, 1);   {push edx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '1+' then
         begin
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$04; fs.Write(tmp, 1);
           tmp:=$24; fs.Write(tmp, 1);  {inc [esp]}
           continue;
         end;
      if u1.token = '1-' then
         begin
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$0c; fs.Write(tmp, 1);
           tmp:=$24; fs.Write(tmp, 1);  {dec [esp]}
           continue;
         end;
      if u1.token = 'and' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$23; fs.Write(tmp, 1);
           tmp:=$c3; fs.Write(tmp, 1);   {and eax, ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'or' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$0b; fs.Write(tmp, 1);
           tmp:=$c3; fs.Write(tmp, 1);   {or eax, ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'not' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$f7; fs.Write(tmp, 1);
           tmp:=$d0; fs.Write(tmp, 1);   {not eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'xor' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$33; fs.Write(tmp, 1);
           tmp:=$c3; fs.Write(tmp, 1);   {xor eax, ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '>' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$3b; fs.Write(tmp, 1);
           tmp:=$c3; fs.Write(tmp, 1);   {cmp eax, ebx}
           tmp:=$b8; fs.Write(tmp, 1);
           tmp:=$ffffffff; fs.Write(tmp, 4);   {mov eax, -1}
           tmp:=$7f; fs.Write(tmp, 1);
           tmp:=$02; fs.Write(tmp, 1);   {jg m8}
           tmp:=$33; fs.Write(tmp, 1);
           tmp:=$c0; fs.Write(tmp, 1);   {xor eax, eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '<' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$3b; fs.Write(tmp, 1);
           tmp:=$c3; fs.Write(tmp, 1);   {cmp eax, ebx}
           tmp:=$b8; fs.Write(tmp, 1);
           tmp:=$ffffffff; fs.Write(tmp, 4);   {mov eax, -1}
           tmp:=$7c; fs.Write(tmp, 1);
           tmp:=$02; fs.Write(tmp, 1);   {jl m8}
           tmp:=$33; fs.Write(tmp, 1);
           tmp:=$c0; fs.Write(tmp, 1);   {xor eax, eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '=' then
         begin
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$3b; fs.Write(tmp, 1);
           tmp:=$c3; fs.Write(tmp, 1);   {cmp eax, ebx}
           tmp:=$b8; fs.Write(tmp, 1);
           tmp:=$ffffffff; fs.Write(tmp, 4);   {mov eax, -1}
           tmp:=$74; fs.Write(tmp, 1);
           tmp:=$02; fs.Write(tmp, 1);   {je m8}
           tmp:=$33; fs.Write(tmp, 1);
           tmp:=$c0; fs.Write(tmp, 1);   {xor eax, eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'here' then
         begin
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$35; fs.Write(tmp, 1);
           u2.Find('here', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push m32}
           continue;
         end;
      if u1.token = 'allot' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$01; fs.Write(tmp, 1);
           tmp:=$05; fs.Write(tmp, 1);
           u2.Find('here', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {add here, eax}
           continue;
         end;
      if u1.token = '@' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1);   {mov eax, [eax]}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = '!' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}
           tmp:=$89; fs.Write(tmp, 1);
           tmp:=$18; fs.Write(tmp, 1);   {mov [eax], ebx}
           continue;
         end;
      if u1.token = 'LoadLibrary' then
         begin
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('LoadLibraryA')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'GetProcAddress' then
         begin
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('GetProcAddress')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call ebx}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'execute' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d0; fs.Write(tmp, 1); {call eax}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'if' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$0b; fs.Write(tmp, 1);
           tmp:=$c0; fs.Write(tmp, 1);   {or eax, eax}
           tmp:=$0f; fs.Write(tmp, 1);
           tmp:=$84; fs.Write(tmp, 1);
           u3.PUSH(fs.Position);
           u3.PUSH(2);
           tmp:=$0; fs.Write(tmp, 4);    {jz metka32}
           continue;
         end;
      if u1.token = 'then' then
         begin
           if u3.POP = 2 then
             begin
               tmp := u3.POP;
               pdword(dword(fs.Memory) + tmp)^ := fs.Position - tmp - 4;
             end;
           continue;
         end;
      if u1.token = 'else' then
         begin
           if u3.POP = 2 then
             begin
               tmp:=$e9; fs.Write(tmp, 1);
               tmp:=$0; fs.Write(tmp, 4); {jmp 32}
               tmp := u3.POP;
               pdword(dword(fs.Memory) + tmp)^ := fs.Position - tmp - 4;
               u3.PUSH(fs.Position - 4);
               u3.PUSH(2);
             end;
           continue;
         end;
      if u1.token = 'begin' then
         begin
           u3.PUSH(fs.Position);
           u3.PUSH(3);
           continue;
         end;
      if u1.token = 'until' then
         begin
           if u3.POP = 3 then
             begin
               tmp:=$58; fs.Write(tmp, 1);   {pop eax}
               tmp:=$0b; fs.Write(tmp, 1);
               tmp:=$c0; fs.Write(tmp, 1);   {or eax, eax}
               tmp:=$0f; fs.Write(tmp, 1);
               tmp:=$84; fs.Write(tmp, 1);
               tmp := u3.POP;
               tmp :=tmp - (fs.Position + 4);fs.Write(tmp, 4);    {jz metka32}
             end;
           continue;
         end;
      if u1.token = 'while' then
         begin
           if u3.POP = 3 then
             begin
               tmp:=$58; fs.Write(tmp, 1);   {pop eax}
               tmp:=$0b; fs.Write(tmp, 1);
               tmp:=$c0; fs.Write(tmp, 1);   {or eax, eax}
               tmp:=$0f; fs.Write(tmp, 1);
               tmp:=$84; fs.Write(tmp, 1);
               tmp := u3.POP;
               u3.PUSH(fs.Position);
               u3.PUSH(tmp);
               u3.PUSH(4);
               tmp :=0;fs.Write(tmp, 4);    {jz metka32}
             end;
           continue;
         end;
      if u1.token = 'repeat' then
         begin
           if u3.POP = 4 then
             begin
               tmp:=$e9; fs.Write(tmp, 1);
               tmp := u3.POP;
               tmp :=tmp - (fs.Position + 4);fs.Write(tmp, 4);    {jmp cmesh32}
               tmp := u3.POP;
               pdword(dword(fs.Memory) + tmp)^ := fs.Position - (tmp + 4);
             end;
           continue;
         end;
      if u1.token = 'type' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$5b; fs.Write(tmp, 1);   {pop ebx}

           tmp:=$6A; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1);   {push 0; i32}
           tmp:=$68; fs.Write(tmp, 1);
           u2.Find('msg_l', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push offset msg_l}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           tmp:=$53; fs.Write(tmp, 1);   {push ebx}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$35; fs.Write(tmp, 1);
           u2.Find('STDOUT', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push m32}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$1d; fs.Write(tmp, 1);
           tmp:=FindAddrImport('WriteConsoleA')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$d3; fs.Write(tmp, 1); {call [ebx]}
           continue;
         end;
      if u1.token = '>r' then
         begin
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$83; fs.Write(tmp, 1);
           tmp:=$ed; fs.Write(tmp, 1);
           tmp:=$04; fs.Write(tmp, 1); {sub ebp,4}
           tmp:=$89; fs.Write(tmp, 1);
           tmp:=$45; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1); {mov [ebp],eax}
           continue;
         end;
      if u1.token = 'r>' then
         begin
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$45; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1); {mov eax,[ebp]}
           tmp:=$83; fs.Write(tmp, 1);
           tmp:=$c5; fs.Write(tmp, 1);
           tmp:=$04; fs.Write(tmp, 1); {add ebp, 4}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'r@' then
         begin
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$45; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1); {mov eax,[ebp]}
           tmp:=$50; fs.Write(tmp, 1);   {push eax}
           continue;
         end;
      if u1.token = 'create' then
         begin
           {mov data_create, here}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$35; fs.Write(tmp, 1);
           u2.Find('here', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push m32}
           tmp:=$58; fs.Write(tmp, 1);   {pop eax}
           tmp:=$a3; fs.Write(tmp, 1);
           u2.Find('data_create', _adr, _size);
           tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {mov data_create, eax}
           continue;
         end;
      if u1.token = 'does>' then
         begin
           {exit}
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$45; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1); {mov eax,[ebp]}
           tmp:=$83; fs.Write(tmp, 1);
           tmp:=$c5; fs.Write(tmp, 1);
           tmp:=$04; fs.Write(tmp, 1); {add ebp, 4}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$e0; fs.Write(tmp, 1);   {jmp eax}
           u2.Add('does_'+word_now, fs.Position - _fCode + _BaseOfCode ,0);
           continue;
         end;
      if u1.token = ':' then
         begin
           u1.GetToken1;
           u2.Add(u1.token, fs.Position - _fCode + _BaseOfCode ,0);
           word_now := u1.token;
           if u1.token = EntryPoint then
             begin
                //
                tmp:=$68; fs.Write(tmp, 1);
                tmp:=dword(-11); fs.Write(tmp, 4);   {push STD_OUTPUT_HANDLE}
                tmp:=$8b; fs.Write(tmp, 1);
                tmp:=$1d; fs.Write(tmp, 1);
                tmp:=FindAddrImport('GetStdHandle')+ _ImageBase; fs.Write(tmp, 4); {mov ebx, [i32]}
                tmp:=$ff; fs.Write(tmp, 1);
                tmp:=$d3; fs.Write(tmp, 1); {call [ebx]}
                tmp:=$a3; fs.Write(tmp, 1);
                u2.Find('STDOUT', _adr, _size);
                tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {mov STDOUT, eax}
                tmp:=$bd; fs.Write(tmp, 1);
                tmp:=_ImageBase + size_of_image - 1; fs.Write(tmp, 4);   {mov ebp, i32}
                //   
                tmp:=$8b; fs.Write(tmp, 1);
                tmp:=$05; fs.Write(tmp, 1);
                tmp:=FindAddrImport('ExitProcess')+ _ImageBase; fs.Write(tmp, 4); {mov eax, [i32]}
                tmp:=$83; fs.Write(tmp, 1);
                tmp:=$ed; fs.Write(tmp, 1);
                tmp:=$04; fs.Write(tmp, 1); {sub ebp,4}
                tmp:=$89; fs.Write(tmp, 1);
                tmp:=$45; fs.Write(tmp, 1);
                tmp:=$00; fs.Write(tmp, 1); {mov [ebp],eax}
             end
           else
             begin
                tmp:=$58; fs.Write(tmp, 1);   {pop eax}
                tmp:=$83; fs.Write(tmp, 1);
                tmp:=$ed; fs.Write(tmp, 1);
                tmp:=$04; fs.Write(tmp, 1); {sub ebp,4}
                tmp:=$89; fs.Write(tmp, 1);
                tmp:=$45; fs.Write(tmp, 1);
                tmp:=$00; fs.Write(tmp, 1); {mov [ebp],eax}
             end;
           continue;
         end;
      if u1.token = ';' then
         begin
           word_now := '';
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$45; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1); {mov eax,[ebp]}
           tmp:=$83; fs.Write(tmp, 1);
           tmp:=$c5; fs.Write(tmp, 1);
           tmp:=$04; fs.Write(tmp, 1); {add ebp, 4}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$e0; fs.Write(tmp, 1);   {jmp eax}
           continue;
         end;
      if u1.token = 'exit' then
         begin
           tmp:=$8b; fs.Write(tmp, 1);
           tmp:=$45; fs.Write(tmp, 1);
           tmp:=$00; fs.Write(tmp, 1); {mov eax,[ebp]}
           tmp:=$83; fs.Write(tmp, 1);
           tmp:=$c5; fs.Write(tmp, 1);
           tmp:=$04; fs.Write(tmp, 1); {add ebp, 4}
           tmp:=$ff; fs.Write(tmp, 1);
           tmp:=$e0; fs.Write(tmp, 1);   {jmp eax}
           continue;
         end;
      if u2.Find(u1.token, _adr, _size) then
         begin
           if _adr = 0 then u4.AddForZero(u1.token, fs.Position + 1);
           if _size = 0 then
             begin
               tmp:=$e8; fs.Write(tmp, 1);
               tmp:=dword((_adr - _BaseOfCode) - (fs.Position - _fCode + 4)) ; fs.Write(tmp, 4);   {call 32}
               //  
               if u2.Find('does_'+u1.token, _adr, _size) then
                  begin
                    u1.GetToken1;
                    u2.Add(u1.token, 0, 0);
                    u2.Add('data_'+u1.token, $ffffffff, 4);
                    u2.Add(u1.token + '_does', _adr, 0);
                    {mov data_*, data_create}
                    tmp:=$ff; fs.Write(tmp, 1);
                    tmp:=$35; fs.Write(tmp, 1);
                    u2.Find('data_create', _adr, _size);
                    tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push m32}
                    tmp:=$58; fs.Write(tmp, 1);   {pop eax}
                    tmp:=$a3; fs.Write(tmp, 1);
                    u2.Find('data_'+u1.token, _adr, _size);
                    tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {mov data_*, eax}
                  end;
             end;
           continue;
         end;
      if u1.token_type = u1.NUM then
         begin
           tmp:=$68; fs.Write(tmp, 1);
           tmp:=StrToInt(u1.token) ; fs.Write(tmp, 4);   {push NUM}
           continue;
         end;
      if u1.token_type = u1.STROKA then
         begin
           tmp:=$68; fs.Write(tmp, 1);
           _stroka := u1.token;
           inc(s_count);
           tmp := u2.Add('str_'+IntToHex(s_count, 4), $ffffffff, length(_stroka)+2+1);
           PWord(dword(fs.Memory) + _fData + (tmp - _BaseOfData))^ := length(_stroka);
           StrCopy(pchar(dword(fs.Memory) + _fData + (tmp - _BaseOfData) + 2),Pchar(_stroka));
           tmp:= tmp + _ImageBase; fs.Write(tmp, 4);   {push addr STROKA}
           continue;
         end;
    end;


  //----------------------------------------
  if u2.Find(EntryPoint, _adr, _size) then
     PImageNtHeaders(dword(fs.Memory) + 256).OptionalHeader.AddressOfEntryPoint := _adr;
  //---------------- ----------
  u4.Sort;
  word_now := u4.mas_obj_z[1].nm + '*';
  for i := 1 to u4.now_obj_z do
       begin
         if word_now <> u4.mas_obj_z[i].nm then
            begin
               word_now := u4.mas_obj_z[i].nm;
               tmp := u4.mas_obj_z[i].Position;
               pdword(dword(fs.Memory) + tmp)^ := fs.Position - (tmp + 4);
               szi := fs.Position;
               //
               tmp:=$58; fs.Write(tmp, 1);   {pop eax}
               tmp:=$83; fs.Write(tmp, 1);
               tmp:=$ed; fs.Write(tmp, 1);
               tmp:=$04; fs.Write(tmp, 1); {sub ebp,4}
               tmp:=$89; fs.Write(tmp, 1);
               tmp:=$45; fs.Write(tmp, 1);
               tmp:=$00; fs.Write(tmp, 1); {mov [ebp],eax}
               //   
               tmp:=$ff; fs.Write(tmp, 1);
               tmp:=$35; fs.Write(tmp, 1);
               u2.Find('data_'+u4.mas_obj_z[i].nm , _adr, _size);
               tmp:=_adr + _ImageBase; fs.Write(tmp, 4);   {push m32}
               //  does>
               u2.Find(u4.mas_obj_z[i].nm+'_does' , _adr, _size);
               tmp:=$e9; fs.Write(tmp, 1);
               tmp :=(_fCode + (_adr - _BaseOfCode)) - (fs.Position + 4);fs.Write(tmp, 4);    {jmp cmesh32}
            end
         else
            begin
               tmp := u4.mas_obj_z[i].Position;
               pdword(dword(fs.Memory) + tmp)^ := szi - (tmp + 4);
            end
       end;
  //----------------------------------------
  fs.SaveToFile(fn_exe);
  fs.Free;

  u2.View(Copy(fn_exe, 1, length(fn_exe)-3)+'map');
end;

end.


